{
  description = "virtual environments";

  inputs.devshell.url = "github:numtide/devshell";
  inputs.flake-utils.url = "github:numtide/flake-utils";
  inputs.naersk.url = "github:nix-community/naersk";

  outputs = { self, flake-utils, devshell, nixpkgs, naersk }:
    flake-utils.lib.eachDefaultSystem (system: let
      pkgs = nixpkgs.legacyPackages."${system}";
      naersk-lib = naersk.lib."${system}";
    in {
      defaultPackage = naersk-lib.buildPackage {
        pname = "ddcmqtt";
        root = ./.;
        nativeBuildInputs = with pkgs; [ pkgconfig libudev ];
      };
      /* devshell currently not really working for stuff that needs pkgconfig/libs
      devShell =
        let pkgs = import nixpkgs {
          inherit system;

          overlays = [ devshell.overlay ];
        };
        in
        pkgs.devshell.mkShell {
          packages = with pkgs; [ rustc cargo gcc ];
          nativeBuildInputs = with pkgs; [ libudev pkgconfig ];
        };
      */
      devshell = pkgs.mkShell{
        nativeBuildInputs = with pkgs; [ rustc cargo libudev pkgconfig ];
      };
    });
}
