use ddc_i2c::{I2cDeviceEnumerator, I2cDeviceDdc};
use ddc::Ddc;

use ::ddcmqtt::{StdError};

fn main() -> StdError<()> {
    let args_: Vec<_> = std::env::args().skip(1).collect();
    let args: Vec<&str> = args_.iter().map(|s| &**s).collect();
    match args.as_slice() {
        ["brightness", arg] => ddc_all(0x10, arg.parse::<u16>()?),
        ["input", arg] => ddc_all(0x60, arg.parse::<u16>()?),
        _ => Err("Bad usage".into()),

    }?;
    Ok(())
}

fn ddc_all(feat: u8, val: u16) -> StdError<()> {
    for mut display in I2cDeviceEnumerator::new()? {
        display.set_vcp_feature(feat, val)?;
    }
    Ok(())
}
